#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#if defined(WIN32)
//#  pragma comment(linker, "/subsystem:\"windows\" /entry:\"mainCRTStartup\"")
#  include "glut.h"
#  include "glext.h"
#elif defined(__APPLE__) || defined(MACOSX)
#  include <GLUT/glut.h>
#else
#  define GL_GLEXT_PROTOTYPES
#  include <GL/glut.h>
#endif

/*
** 
*/
static const GLfloat lightpos[] = { 0.0, 0.0, 1.0, 0.0 }; /* ֡ */
static const GLfloat lightcol[] = { 1.0, 1.0, 1.0, 1.0 }; /* ľܸ */
static const GLfloat lightamb[] = { 0.1, 0.1, 0.1, 1.0 }; /* Ķ */

/*
** ƥ
*/
#define TEXWIDTH  256                           /* ƥ */
#define TEXHEIGHT 256                           /* ƥι⤵ */
static const char texfile[] = "texture.raw";    /* ƥե̾ */

/*
** 
*/
static void init()
{
  GLint buffers, samples;
  GLubyte texture[TEXHEIGHT][TEXWIDTH][4];
  FILE *fp;
  
  /* ƥɤ߹ */
  if ((fp = fopen(texfile, "rb")) != NULL) {
    fread(texture, sizeof texture, 1, fp);
    fclose(fp);
  }
  else {
    perror(texfile);
  }
  
  /* ƥϥñ̤˵ͤޤƤ */
  glPixelStorei(GL_UNPACK_ALIGNMENT, 4);
  
  /* ߥåץޥåפμư */
  glTexParameteri(GL_TEXTURE_2D, GL_GENERATE_MIPMAP, GL_TRUE);
  
  /* ƥγ */
  glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, TEXWIDTH, TEXHEIGHT, 0,
    GL_RGBA, GL_UNSIGNED_BYTE, texture);
  
  /* ƥ硦̾ˡλ */
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_LINEAR);
  
  /* ƥη֤ˡλ */
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);
  
  /* ƥĶ */
  glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
  
  /*  */
  glClearColor(1.0, 1.0, 1.0, 1.0);
  glEnable(GL_DEPTH_TEST);
  glDisable(GL_CULL_FACE);
  
  /* ν */
  glEnable(GL_LIGHTING);
  glEnable(GL_LIGHT0);
  glLightfv(GL_LIGHT0, GL_DIFFUSE, lightcol);
  glLightfv(GL_LIGHT0, GL_SPECULAR, lightcol);
  glLightfv(GL_LIGHT0, GL_AMBIENT, lightamb);
  glLightModeli(GL_LIGHT_MODEL_TWO_SIDE, GL_TRUE);
  
  /* ޥץ󥰤ξ֤γǧ */
  glGetIntegerv(GL_SAMPLE_BUFFERS, &buffers);
  glGetIntegerv(GL_SAMPLES, &samples);
  printf("buffers = %d, samples = %d\n", buffers, samples);
}

/*
** 
*/
static void scene(void)
{
  static const GLfloat color[] = { 1.0, 1.0, 1.0, 1.0 };  /*  () */
  
  /*  */
  glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, color);
  
  /* ƥޥåԥ󥰳 */
  glEnable(GL_TEXTURE_2D);
  
  /* Σѷ */
  glNormal3d(0.0, 0.0, 1.0);
  glBegin(GL_QUADS);
  glTexCoord2d(0.0, 1.0);
  glVertex3d(-1.0, -1.0,  0.0);
  glTexCoord2d(1.0, 1.0);
  glVertex3d( 1.0, -1.0,  0.0);
  glTexCoord2d(1.0, 0.0);
  glVertex3d( 1.0,  1.0,  0.0);
  glTexCoord2d(0.0, 0.0);
  glVertex3d(-1.0,  1.0,  0.0);
  glEnd();
  
  /* ƥޥåԥ󥰽λ */
  glDisable(GL_TEXTURE_2D);
}


/****************************
** GLUT ΥХåؿ **
****************************/

/* ȥåܡѴؿ */
#include "trackball.h"

static void display(void)
{
  /* ǥӥ塼Ѵ */
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  
  /* ΰ֤ */
  glLightfv(GL_LIGHT0, GL_POSITION, lightpos);
  
  /* ΰưʪΤ˰ư*/
  glTranslated(0.0, 0.0, -3.0);
  
  /* ȥåܡˤž */
  glMultMatrixd(trackballRotation());
  
  /* ̥ꥢ */
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  
  /* ޥץ󥰤ͭˤ */
  glEnable(GL_MULTISAMPLE);
  
  /* եͤ򥵥ץʤΨˤ */
  glEnable(GL_SAMPLE_ALPHA_TO_COVERAGE);
  
  /*  */
  scene();
  glPushMatrix();
  glRotated(90.0, 0.0, 1.0, 0.0);
  scene();
  glPopMatrix();
  
  /* ֥Хåե */
  glutSwapBuffers();
}

static void resize(int w, int h)
{
  /* ȥåܡ뤹ϰ */
  trackballRegion(w, h);
  
  /* ɥΤӥ塼ݡȤˤ */
  glViewport(0, 0, w, h);
  
  /* ƩѴλ */
  glMatrixMode(GL_PROJECTION);
  
  /* ƩѴν */
  glLoadIdentity();
  gluPerspective(60.0, (GLdouble)w / (GLdouble)h, 1.0, 100.0);
}

static void idle(void)
{
  /* ̤ؤ */
  glutPostRedisplay();
}

static void mouse(int button, int state, int x, int y)
{
  switch (button) {
  case GLUT_LEFT_BUTTON:
    switch (state) {
    case GLUT_DOWN:
      /* ȥåܡ볫 */
      trackballStart(x, y);
      glutIdleFunc(idle);
      break;
    case GLUT_UP:
      /* ȥåܡ */
      trackballStop(x, y);
      glutIdleFunc(0);
      break;
    default:
      break;
    }
    break;
    default:
      break;
  }
}

static void motion(int x, int y)
{
  /* ȥåܡư */
  trackballMotion(x, y);
}

static void keyboard(unsigned char key, int x, int y)
{
  switch (key) {
  case 'q':
  case 'Q':
  case '\033':
    /* ESC  q  Q 򥿥פ齪λ */
    exit(0);
  default:
    break;
  }
}

/*
** ᥤץ
*/
int main(int argc, char *argv[])
{
  glutInit(&argc, argv);
  glutInitDisplayMode(GLUT_RGB | GLUT_DEPTH | GLUT_DOUBLE | GLUT_MULTISAMPLE);
  glutCreateWindow(argv[0]);
  glutDisplayFunc(display);
  glutReshapeFunc(resize);
  glutMouseFunc(mouse);
  glutMotionFunc(motion);
  glutKeyboardFunc(keyboard);
  init();
  glutMainLoop();
  return 0;
}
